package goastro;

import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import com.google.gson.*;
import goastro.*;
import java.util.*;


public class transactionstrankeygetTest {
	@Test public void transactionstrankeyget() {
		API.setAuthentication("Example_API_Key","Example_Pin");
		API.local_test=true;

		//Building Response
		Map<String, Object> expected_response = new HashMap<String, Object>();
		expected_response.put("type","transaction");
		expected_response.put("key","dnfwxwhz5kvnbgb");
		expected_response.put("refnum","100061");
		expected_response.put("created","2018-12-04 10:48:44");
		expected_response.put("trantype_code","S");
		expected_response.put("trantype","Credit Card Sale");
		expected_response.put("result_code","A");
		expected_response.put("result","Approved");
		expected_response.put("error_code","12");
		expected_response.put("error","Card Number was not between 13 and 16 digits");
		expected_response.put("authcode","314407");
		expected_response.put("status_code","P");
		expected_response.put("status","Authorized (Pending Settlement)");
		expected_response.put("proc_refnum","18120443975126");
			Map<String, Object> creditcard = new HashMap<String, Object>();
			Map<String, Object> creditcard1 = new HashMap<String, Object>();
			creditcard1.put("cardholder","Minerva McGonnegall");
			creditcard1.put("number","4444xxxxxxxx1111");
			creditcard1.put("category_code","A");
			creditcard1.put("entry_mode","swiped");
			creditcard1.put("avs_street","1234 Portkey Ave");
			creditcard1.put("avs_postalcode","90006");
		expected_response.put("creditcard","creditcard");
			Map<String, Object> check = new HashMap<String, Object>();
			Map<String, Object> check2 = new HashMap<String, Object>();
			check2.put("accountholder","Remus Lupin");
			check2.put("routing","123456789");
			check2.put("account","324523524");
			check2.put("account_type","checking");
		expected_response.put("check","check");
			Map<String, Object> avs = new HashMap<String, Object>();
			Map<String, Object> avs3 = new HashMap<String, Object>();
			avs3.put("result_code","YYY");
			avs3.put("result","Address: Match & 5 Digit Zip: Match");
		expected_response.put("avs","avs");
			Map<String, Object> cvc = new HashMap<String, Object>();
			Map<String, Object> cvc4 = new HashMap<String, Object>();
			cvc4.put("result_code","N");
			cvc4.put("result","No Match");
		expected_response.put("cvc","cvc");
			Map<String, Object> batch = new HashMap<String, Object>();
			Map<String, Object> batch5 = new HashMap<String, Object>();
			batch5.put("type","batch");
			batch5.put("key","ft1m9m5p9wgd9mb");
			batch5.put("batchrefnum","12345678");
			batch5.put("sequence","2902");
		expected_response.put("batch","batch");
		expected_response.put("amount","50");
			Map<String, Object> amount_detail = new HashMap<String, Object>();
			Map<String, Object> amount_detail6 = new HashMap<String, Object>();
			amount_detail6.put("subtotal","40.00");
			amount_detail6.put("tax","10.00");
			amount_detail6.put("enable_partialauth","false");
		expected_response.put("amount_detail","amount_detail");
		expected_response.put("ponum","af416fsd5");
		expected_response.put("invoice","98454685");
		expected_response.put("orderid","98454685");
		expected_response.put("description","Antique Pensieve");
			Map<String, Object> billing_address = new HashMap<String, Object>();
			Map<String, Object> billing_address7 = new HashMap<String, Object>();
			billing_address7.put("company","Hogwarts School of Witchcraft and Wizardry");
			billing_address7.put("street","123 Astronomy Tower");
			billing_address7.put("postalcode","10005");
		expected_response.put("billing_address","billing_address");
			Map<String, Object> shipping_address = new HashMap<String, Object>();
			Map<String, Object> shipping_address8 = new HashMap<String, Object>();
			shipping_address8.put("company","Hogwarts School of Witchcraft and Wizardry");
			shipping_address8.put("street","123 Astronomy Tower");
			shipping_address8.put("postalcode","10005");
		expected_response.put("shipping_address","shipping_address");
		List<Map> lineitems = new ArrayList<Map>();
			Map<String, Object> LineItem = new HashMap<String, Object>();
			LineItem.put("name","Antique Pensieve");
			LineItem.put("description","See into your past...");
			LineItem.put("size","Large");
			LineItem.put("color","Bronze");
			LineItem.put("cost","450.00");
			LineItem.put("list_price","500.00");
			LineItem.put("qty","1");
			LineItem.put("sku","68453423");
			LineItem.put("commoditycode","535");
			LineItem.put("discountamount","0");
			LineItem.put("discountrate","0");
			LineItem.put("taxable","");
			LineItem.put("taxamount","45.00");
			LineItem.put("taxclass","NA");
			LineItem.put("taxrate","10");
			LineItem.put("um","EA");
			LineItem.put("category","Antiques");
			LineItem.put("manufacturer","The Ancients");
		lineitems.add(LineItem);
			Map<String, Object> LineItem9 = new HashMap<String, Object>();
			LineItem9.put("name","Antique Pensieve");
			LineItem9.put("description","See into your past...");
			LineItem9.put("size","Large");
			LineItem9.put("color","Bronze");
			LineItem9.put("cost","450.00");
			LineItem9.put("list_price","500.00");
			LineItem9.put("qty","1");
			LineItem9.put("sku","68453423");
			LineItem9.put("commoditycode","535");
			LineItem9.put("discountamount","0");
			LineItem9.put("discountrate","0");
			LineItem9.put("taxable","");
			LineItem9.put("taxamount","45.00");
			LineItem9.put("taxclass","NA");
			LineItem9.put("taxrate","10");
			LineItem9.put("um","EA");
			LineItem9.put("category","Antiques");
			LineItem9.put("manufacturer","The Ancients");
		lineitems.add(LineItem9);
		expected_response.put("lineitems",lineitems);
		List<Map> custom_fields = new ArrayList<Map>();
		expected_response.put("custom_fields",custom_fields);
		expected_response.put("comments","Powerful magical object. Use with caution.");
		expected_response.put("tranterm","multilane");
		expected_response.put("clerk","Madame Malkin");
			Map<String, Object> receipts = new HashMap<String, Object>();
			Map<String, Object> receipts10 = new HashMap<String, Object>();
			receipts10.put("customer","Mail Sent Successfully");
			receipts10.put("merchant","Mail Sent Successfully");
		expected_response.put("receipts","receipts");
			Map<String, Object> customer = new HashMap<String, Object>();
			Map<String, Object> customer11 = new HashMap<String, Object>();
			customer11.put("custkey","ksddgpqgpbs5zkmb");
			customer11.put("custid","10275538");
		expected_response.put("customer","customer");
		expected_response.put("customer_email","noreply@gmail.com");
			Map<String, Object> bin = new HashMap<String, Object>();
			Map<String, Object> bin12 = new HashMap<String, Object>();
			bin12.put("bin","444455");
			bin12.put("type","Debit");
			bin12.put("issuer","Visa");
			bin12.put("bank","Chase Bank");
			bin12.put("country","US");
			bin12.put("country_name","United States");
			bin12.put("country_iso","CA");
			bin12.put("location","http://www.jpmorganchase.com");
			bin12.put("phone","USA");
			bin12.put("category","");
		expected_response.put("bin","bin");
		expected_response.put("clientip","Madame Malkin");
		expected_response.put("source_name","Madame Malkin");
		String encoded_response = API.json_encode(expected_response);
		MockHandler.response = encoded_response;

		//Building Request
		Map<String, Object> reqdata = new HashMap<String, Object>();
		reqdata.put("trankey","Exampletrankey");
		String response = "";
		response = goastro.Transactions.get(reqdata);

		assertEquals("Response did not match ",encoded_response,response);
		assertEquals("Request did not match ",API.json_encode(reqdata),MockHandler.request);
		assertTrue("Path not formatted correctly "+MockHandler.path,MockHandler.path.contains("https://api.goastro.com/api/v2/transactions/Exampletrankey"));
		assertEquals("Method did not match ","GET",MockHandler.method.toUpperCase());
	}
}